
 **********************************************************************************************************
 ***************************Main Program Wild cluster bootstrap with Null imposed. ************************
 **********************************************************************************************************
 
 cap program drop  boot
 	  program boot, rclass
		    syntax varlist [if] [in] ,unit(string) [bots(integer 50)]
local depend =word("`varlist'",1)
local interest=word("`varlist'",2)
local ivs1:list  varlist - depend
local ivs: list ivs1- interest
* cap  drop uR xbR
*args  depend interest  cluster  No(integer 50)
*and the null hypothesis H0: _b[Treatment] = 0.0
* Step 1: *
*Step 1-1) Compute w (if t_0 was 0, it would be the t from the table).
 quietly ivreg2 `depend' `interest' `ivs' , cluster(`unit')
 global w = (_b[`interest'] - .0)/ _se[`interest']
 di "$w'"
 *Step 1-2: fit the restrained constraint. Regress Y on all X except the one we want to test 
  constraint 1 `interest' = .0  //This sets the constraint, Treat=0, Null imposed
  quietly cnsreg `depend' `interest' `ivs' , constraint(1) cluster(`unit')
  mat bR = e(b)
  quietly predict uR , residuals
  quietly predict xbR, xb
  *There is one long vector of residuals uR,  *There also is the restricted linear prediction xbR
   
 ***************************************************************************************************
 simulate  wstar = r(wstar) b=r(b) se=r(se) W_webb=r(wstar_Webb) b_Webb=r(b_Webb) se_Webb=r(se_Webb) ///
 , reps(`bots') saving(wstar_file, replace): getwstar `depend' `interest' `ivs',unit("`unit'") //Acess the getwstar program defined above
 use wstar_file, clear
 gen Test=0
 *Wstar refers to the vector of pvalues from the bootstrap, using the 2-point distribution. $w is the T-stat from the original regression.
 *Then check which share of the bootstraped T-stats is larger than the original one to get p-value
 replace Test = 1 if abs(wstar)>abs($w)  // If Rademacher-based T-stat is larger than tHat from main regression, some might be smaller and some larger. 
 egen Wl=sum(Test)  //Sum up to get the number of bootstrap repetitions for which the tstat indicates significance.
  *Rademacher weights
 scalar Pvalue_Rad=2*Wl/_N  //Two sided test, taking the smaller value of W1 and Ws for absolute values
 *Webb weights
 drop Test Wl 
  gen Test=0
 replace Test = 1 if abs(W_webb)>abs($w)  //Smaller than tHat from main regression
 egen Wl=sum(Test)
 scalar Pvalue_Webb=2*Wl/_N         //_N are all the bootstrap repetitions, in what share of those is the T-stat larger than the original one,  This yields the symmetric bootstrap p-value
 * See http://www.maxwell.syr.edu/uploadedFiles/cpr/events/cpr_camp_econometrics/papers2013/MacKinnon_Webb.pdf page. 8 

 return scalar Pvalue_Rad =Pvalue_Rad
 return scalar Pvalue_Webb =Pvalue_Webb
 use "data processed\public_eupower2.dta", clear
 *restore,preserve
 end
 ********************************************************************************************************
 *********************Program, compare Webb 2014*********************************************************
 ********************************************************************************************************
 cap program drop  getwstar
  program getwstar, rclass
	    syntax varlist [if] [in] ,unit(string)
		local depend =word("`varlist'",1)
local interest=word("`varlist'",2)
local ivs1:list  varlist - depend
local ivs: list ivs1- interest
*	display `interest'
*	display `ivs'
   tempvar ag uRstar yhatstar Webb uRstar_Webb yhatstar_Webb my_uniform
   *Use the rademacher 2-point distribution to simulate Ustar and create new YHats.
   sort `unit' 
   gen `ag' = cond(runiform()<.5, -1, 1) // * Step 2a: * *Form a sample of clusters. Step 2a-1: generate the weights a_g, which are unique to each
   bysort `unit': replace `ag' = `ag'[1]
   gen `uRstar' = uR*`ag'  //  *setp 2a-2: generate uRstar
   gen `yhatstar' = xbR + `uRstar'  //  *step 2a-3: generate yhatstar
   quietly reg  `yhatstar' `interest' `ivs', cluster(`unit')
   return scalar wstar = (_b[`interest'] - .0)/ _se[`interest']
   return scalar b=_b[`interest']
   return scalar se=_se[`interest']
   /*Calculate the Wald test statistic w*b its standard error sȬb are obtained from unrestricted
OLS estimation using the bth pseudo-sample, with s(߱,b) computed
using the same method as that in step 1.  From Cameron and Miller 2008 page 427*/     
   *Use the Webb 6-point distribution to simulate Ustar and create new YHats.
   sort `unit' 
gen `my_uniform' = uniform()  
gen `Webb' = 	(-1) * sqrt(1.5) * (`my_uniform' > (0) & `my_uniform' <= (1/6)) +  ///
						(-1) * sqrt(1) * (`my_uniform' > (1/6) & `my_uniform' <= (2/6))  + ///
						(-1) * sqrt(0.5) * (`my_uniform' > (2/6) & `my_uniform' <= (3/6)) + ///
						(+1) * sqrt(0.5) * (`my_uniform' > (3/6) & `my_uniform' <= (4/6)) + ///
						(+1) * sqrt(1) * (`my_uniform' > (4/6) & `my_uniform' <= (5/6))  + ///
						(+1) * sqrt(1.5) * (`my_uniform' > (5/6) & `my_uniform' <= (6/6)) 
   bysort `unit': replace `Webb' = `Webb'[1]
   gen `uRstar_Webb' = uR*`Webb'
   gen `yhatstar_Webb' = xbR + `uRstar_Webb'
   quietly ivreg2  `yhatstar_Webb' `interest' `ivs', cluster(`unit')
   return scalar wstar_Webb = (_b[`interest'] - .0)/ _se[`interest']
   return scalar b_Webb=_b[`interest']
   return scalar se_Webb=_se[`interest']
 end

 

 
 
 
 ********************************************************************************************
 ******************Null not imposed**********************************************************
 ********************************************************************************************
cap program drop  boot_nonull
 	  program boot_nonull, rclass
*This part runs the restricted or unrestricted regression, and predicts residuals for the bootstrap
syntax varlist [if] [in] ,unit(string) [bots(integer 50)]          //Use different names than existing Stata ones
local depend =word("`varlist'",1)
local interest=word("`varlist'",2)
local ivs1:list  varlist - depend
local ivs: list ivs1- interest
* cap  drop uR xbR
*args  depend interest  cluster  No(integer 50)
*and the null hypothesis H0: _b[Treatment] = 0.0
 
 * Step 1: * Calculat the orginal T-stat and save it
*Step 1-1) Compute w (if my t_0 was 0, it would be the t from the table).
 quietly ivreg2 `depend' `interest' `ivs' , cluster(`unit')
 global binterst= _b[`interest']
 global w = (_b[`interest'] - 0)/ _se[`interest']
 di "$w'"
 
  *Step 1-2 fit the unrestrained equation. Regress Y on all X except the one we want to test 
  quietly ivreg2 `depend' `interest' `ivs' ,  cluster(`unit')
  mat bR = e(b)
  quietly predict uR , residuals
  quietly predict xbR, xb
   *There is one long vector of residuals uR,  *There also is the restricted linear prediction xbR
   
 simulate  wstar = r(wstar) b=r(b) se=r(se) W_webb=r(wstar_Webb) b_Webb=r(b_Webb) se_Webb=r(se_Webb) ///
 , reps(`bots') saving(wstar_file_nonull, replace): getwstarUR `depend' `interest' `ivs',unit("`unit'")  //Acess the program defined below
 
 *************************Use generated file with bootstrap results*****************************
 use wstar_file_nonull, clear
 gen Test=0
 *Wstar refers to the vector of pvalues from the bootstrap, using the 2-point distribution. $w is the T-stat from the original regression.
 *Then check which share of the bootstraped T-stats is larger than the original one to get p-value
 replace Test = 1 if abs(wstar)>abs($w)  // If Rademacher-based T-stat is larger than tHat from main regression, some might be smaller and some larger. 
 egen Wl=sum(Test)  //Sum up to get the number of bootstrap repetitions for which the tstat indicates significance.
  *Rademacher weights
 scalar Pvalue_Rad_nonull=2*Wl/_N  //Two sided test, taking the smaller value of W1 and Ws for absolute values
 
 *Webb weights
 drop Test Wl 
  gen Test=0
 replace Test = 1 if abs(W_webb)>abs($w)  //Smaller than tHat from main regression
 egen Wl=sum(Test)
  scalar Pvalue_Webb_nonull=2*Wl/_N      //_N are all the bootstrap repetitions, in what share of those is the T-stat larger than the original one, 2* due to twosided test

 return scalar Pvalue_Rad_nonull =Pvalue_Rad_nonull
 return scalar Pvalue_Webb_nonull  =Pvalue_Webb_nonull
 use "data processed\public_eupower2.dta", clear
 *restore,preserve
 end
 **************************************************************************************************** 
 *******************This runs the test in each bootstrap sample***************************************
 ***************************************************************************************************** 
cap program drop  getwstarUR
program getwstarUR, rclass
	    syntax varlist [if] [in] ,unit(string)
		local depend =word("`varlist'",1)
local interest=word("`varlist'",2)
local ivs1:list  varlist - depend
local ivs: list ivs1- interest
*	display `interest'
*	display `ivs'
   tempvar ag uRstar yhatstar Webb uRstar_Webb yhatstar_Webb my_uniform
   *Use the rademacher 2-point distribution to simulate Ustar and create new YHats.
   sort `unit' 
   gen `ag' = cond(runiform()<.5, -1, 1) // * Step 2a: * *Form a sample of clusters. Step 2a-1: generate the weights a_g, which are unique to each
   bysort `unit': replace `ag' = `ag'[1]
   gen `uRstar' = uR*`ag'  //  *setp 2a-2: generate uRstar
   gen `yhatstar' = xbR + `uRstar'  //  *step 2a-3: generate yhatstar
   quietly regress  `yhatstar' `interest' `ivs', cluster(`unit')
   return scalar wstar = (_b[`interest'] - $binterst)/ _se[`interest']
   return scalar b=_b[`interest']
   return scalar se=_se[`interest']
/*Calculate the Wald test statistic w*b its standard error sȬb are obtained from unrestricted
OLS estimation using the bth pseudo-sample, with s(߱,b) computed
using the same method as that in step 1.  From Cameron and Miller 2008 page 427*/     *Use the Webb 6-point distribution to simulate Ustar and create new YHats.
sort `unit' 
gen `my_uniform' = uniform()  
gen `Webb' = 	(-1) * sqrt(1.5) * (`my_uniform' > (0) & `my_uniform' <= (1/6)) +  ///
						(-1) * sqrt(1) * (`my_uniform' > (1/6) & `my_uniform' <= (2/6))  + ///
						(-1) * sqrt(0.5) * (`my_uniform' > (2/6) & `my_uniform' <= (3/6)) + ///
						(+1) * sqrt(0.5) * (`my_uniform' > (3/6) & `my_uniform' <= (4/6)) + ///
						(+1) * sqrt(1) * (`my_uniform' > (4/6) & `my_uniform' <= (5/6))  + ///
						(+1) * sqrt(1.5) * (`my_uniform' > (5/6) & `my_uniform' <= (6/6)) 
   bysort `unit': replace `Webb' = `Webb'[1]
   gen `uRstar_Webb' = uR*`Webb'
   gen `yhatstar_Webb' = xbR + `uRstar_Webb'
   quietly ivreg2  `yhatstar_Webb' `interest' `ivs', cluster(`unit')
   return scalar wstar_Webb = (_b[`interest'] - $binterst)/ _se[`interest']
   return scalar b_Webb=_b[`interest']
   return scalar se_Webb=_se[`interest']
 end

 
 
 
 
 
 
 
 
***************************************************************************************************
*******************Randomization inference*********************************************************
*************************************************************************************************** 
cap program drop  RITdef
program define RITdef, rclass
syntax varlist [if] [in] ,unit(string)        //Use different names than existing Stata ones
local depend =word("`varlist'",1)
local interest=word("`varlist'",2)
local ivs1:list  varlist - depend
local ivs: list ivs1- interest
  ******************************Preparation of data
****************Conley and Taber	
global treated Denmark Netherlands Ireland Luxembourg Latvia Austria

use "data processed\public_eupower2.dta", clear	
xtset country_id year 
replace country_id=country_id-2 if country_id>=23   //More convenient
/* Create an indicator for when the treatment changed*/
*the capture command take care of problems when the variables to be created already existr
quietly cap  bys country_id:egen treat=sum(`interest')
* ivreg2  ccap_pct natcom $controls   $years  Dcountry* ttrend*, noc cluster(country_name year)
ivreg2  `depend' natcom `interest' `ivs', noc cluster(`unit')

 quietly cap  drop res1
 predict res1, res 
 sum res1 if treat>0 ,detail
 sum res1 if treat==0 ,detail
 
*Generate Projection of y variable conditional on controls and country and year effects
*Conley and Taber, p.155. Ytilda equals the residuals from a projection of the variable 
*on group and time indicators, projection = regression on. Project on control variables too here to partial them out.
/* Create an indicator for the treatment changed*/
quietly cap  bys country_id:egen treat=sum(natcom)
**Generate baseline coefficient

/* Predict residuals from regression */
*ivreg2  ccap_pct natcom $controls   $years ttrend* Dcountry*, noc cluster(country_name year)
ivreg2  `depend' natcom `interest' `ivs', noc cluster(`unit')
quietly cap  drop eta
predict eta, res 
replace eta=eta+_b[`interest']*`interest'

************ Create d tilde variable, different for more ocuntries*********************
quietly cap  drop count
quietly cap  drop dbar*
quietly cap  drop dtil*
forvalues i=1(1)25 {  
	egen count=mean(`interest') if country_id==`i'
	disp "Shout" `i'
	quietly cap  estpost sum count
	quietly cap  mat T=e(mean) 
	quietly cap  scalar test=T[1,1]
	quietly cap  scalar list test
	*quietly cap  display " Countryid" `i'
	if test!=0  {
		egen dbar`i'=mean(`interest') if country_id==`i'  //Mean of treatment for one case
	gen dtil`i'=`interest'- dbar`i'  
	drop dbar`i'
	}
	quietly cap  drop count 
 }
 

  quietly cap  drop dtilX*
forvalues i=1(1)25 {   
 capture quietly bysort year: egen dtilX`i'=mean(dtil`i')  //Dtilda for each treatment should take same value for each country
 capture quietly  replace dtil`i'= dtilX`i' if dtil`i'==.
} 
 ****************************************************************************************************************
 *Now we have 6 vectors with treatments, and 27 vectors with residuals, considering all as controls
**********************
 save "data processed\Random.dta",replace  
 cap noisily saveold "data processed\Random.dta",replace version(12) 
 end
 ****************************************************************************************************************
 
 cap program drop  RITsim
 program define RITsim, rclass
  display "Sofar"
 cap  drop dtil
 gen dtil=.  //generate treatment variable which has to be filled randomly 
 
 forvalues i = 1(1)25 {
  local draw=ceil(uniform()*25)
  disp "i is = " `i' "  Drawn number " `draw'
  local test=inlist(`draw',2, 7 ,9 ,10, 11, 24 )
  disp "Test if treated " `test'
		while `draw'==`i' | `test'==0 {  //Do not use the dtil for the actual country that had the treatment, draw another number
		  local draw=ceil(uniform()*25)
		  disp "i is = " `i' " Drawn number " `draw'
		    local test=inlist(`draw',2, 7 ,9 ,10, 11, 24 )
		  }
		replace dtil= dtil`draw'    if country_id==`i' 
}
		
xtivreg2 eta dtil, cluster( country_id)	fe

return scalar tstar = (_b[dtil] - .0)/ _se[dtil]
return scalar betastar =_b[dtil]
end

 ****************************************************************************************************************
cap program drop  RIT
program define RIT, rclass
syntax  varlist [if] [in], [bots(integer 50)]        //Use different names than existing Stata ones
 
simulate tstar= r(tstar) betastar=r(betastar)  , reps(`bots') ///
saving(RIT_file.dta, replace): RITsim 
 
use RIT_file.dta,clear
quietly cap  drop Test
quietly cap  drop W1
  gen Test=0
 replace Test = 1 if abs(tstar)>abs($treat_t)  // If Rademache-based T-stat is larger than tHat from main regression, some might be smaller and some larger. 
 egen Wl=sum(Test)  //Sum up to get the number of bootstrap repetitions for which the tstat indicates significance.
 scalar Pvalue_RIT=2*Wl/_N  //Two sided test, taking the smaller value of W1 and Ws for absolute values
 scalar list Pvalue_RIT
*RI-beta
quietly cap  drop Test
quietly cap  drop W1
  gen Test=0
 replace Test = 1 if abs(betastar)>abs($treat_coeff)  // If Rademache-based T-stat is larger than tHat from main regression, some might be smaller and some larger. 
 egen W1=sum(Test)  //Sum up to get the number of bootstrap repetitions for which the tstat indicates significance.
 scalar Pvalue_RIbeta=2*W1/_N  //Two sided test, taking the smaller value of W1 and Ws for absolute values
 scalar list Pvalue_RIbeta 
 
return scalar Pvalue_RIbeta=Pvalue_RIbeta
return scalar Pvalue_RIT=Pvalue_RIT

end
**************************************************************************************	







***************************************************************************************************************
**************************Combination Extreme bounds with leaving out individual countries*********************
***************************************************************************************************************
 cap program drop  eba_country
 program eba_country, rclass
 syntax [, obs(integer 1) controls(integer 1) ]
 *syntax varlist [if] [in]        //Use different names than existing Stata ones
 *syntax varlist [if] [in] ,unit(string) [bots(integer 50)]          //Use different names than existing Stata ones
  use "data processed\public_eupower2.dta", clear
 
global clist 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 25 26 27 
local ix = floor(runiform(0,1)*`obs'+1)

local z = 1
foreach var in $controlsX {
global control`z' `var'
local z = `z'+1
}
local ic = floor(runiform(0,1)*`controls'+1)
global control`ic'     //disactivates control for one randomly chosen control variable

xtivreg2 ccap_pct natcom  $control1	$control2	$control3	$control4	$control5	$control6	$control7	$control8	$control9	$control10	$control11 $control12  ///
$years   if country_id!=`ix', fe cluster(country_name year)
test natcom=0
return scalar pval= r(p) 
return scalar b=_b[natcom ]
return scalar se=_se[natcom ]

end

 
 
 